;---------------------------------------------------------------------------
;
;		Standard Keyboard Definitions and Structures
;
;     Copyright (c) 1999-2000 by Thomas Kjoernes, all rights reserved.
;
;---------------------------------------------------------------------------

KB_LAYOUT		STRUC
klName			DB	2 DUP (?)
klFlags			DW	?
klTableMain		DD	?
klTableAltGr		DD	?
klTableExtended		DD	?
KB_LAYOUT		ENDS

;---------------------------------------------------------------------------
; IBM Keyboard Scancodes
;---------------------------------------------------------------------------

KB_SCAN_ESC		EQU	01h
KB_SCAN_BACKSPACE	EQU	0Eh
KB_SCAN_TAB		EQU	0Fh
KB_SCAN_ENTER		EQU	1Ch
KB_SCAN_CTRL		EQU	1Dh
KB_SCAN_LEFT_SHIFT	EQU	2Ah
KB_SCAN_SLASH		EQU	35h
KB_SCAN_RIGHT_SHIFT	EQU	36h
KB_SCAN_PRTSCR		EQU	37h
KB_SCAN_ALT		EQU	38h
KB_SCAN_SPACE		EQU	39h
KB_SCAN_CAPS_LOCK	EQU	3Ah
KB_SCAN_F1		EQU	3Bh
KB_SCAN_F2		EQU	3Ch
KB_SCAN_F3		EQU	3Dh
KB_SCAN_F4		EQU	3Eh
KB_SCAN_F5		EQU	3Fh
KB_SCAN_F6		EQU	40h
KB_SCAN_F7		EQU	41h
KB_SCAN_F8		EQU	42h
KB_SCAN_F9		EQU	43h
KB_SCAN_F10		EQU	44h
KB_SCAN_NUM_LOCK	EQU	45h
KB_SCAN_SCROLL_LOCK	EQU	46h
KB_SCAN_HOME		EQU	47h
KB_SCAN_UP		EQU	48h
KB_SCAN_PGUP		EQU	49h
KB_SCAN_LEFT		EQU	4Bh
KB_SCAN_RIGHT		EQU	4Dh
KB_SCAN_END		EQU	4Fh
KB_SCAN_DOWN		EQU	50h
KB_SCAN_PGDN		EQU	51h
KB_SCAN_INS		EQU	52h
KB_SCAN_DEL		EQU	53h
KB_SCAN_LEFT_WIN	EQU	5Bh
KB_SCAN_RIGHT_WIN	EQU	5Ch
KB_SCAN_MENU		EQU	5Dh
KB_SCAN_LAST		EQU	5Fh
KB_SCAN_RELEASE		EQU	80h

;---------------------------------------------------------------------------
; IBM Keyboard Special Return Codes
;---------------------------------------------------------------------------

KB_ERROR		EQU	000h
KB_BAT_SUCCESS		EQU	0AAh
KB_ACK			EQU	0FAh
KB_BAT_FAILURE_1	EQU	0FCh
KB_BAT_FAILURE_2	EQU	0FDh
KB_RESEND		EQU	0FEh
KB_OVERRUN		EQU	0FFh

;---------------------------------------------------------------------------
; IBM Keyboard Command
;---------------------------------------------------------------------------

KB_CMD_RESET		EQU	0FFh
KB_CMD_READ_ID		EQU	0F2h
KB_CMD_SET_SPEED	EQU	0F3h
KB_CMD_SET_ENABLE	EQU	0F4h
KB_CMD_SET_DISABLE	EQU	0F5h

KB_DELAY_250		EQU	00000000b
KB_DELAY_500		EQU	00100000b
KB_DELAY_750		EQU	01000000b
KB_DELAY_1000		EQU	01100000b

KB_RATE_30		EQU	00000000b
KB_RATE_24		EQU	00000010b
KB_RATE_20		EQU	00000100b
KB_RATE_16		EQU	00000111b
KB_RATE_12		EQU	00001010b
KB_RATE_10		EQU	00001100b
KB_RATE_8		EQU	00001111b
KB_RATE_6		EQU	00010010b
KB_RATE_5		EQU	00010100b
KB_RATE_4		EQU	00010111b
KB_RATE_3		EQU	00011010b
KB_RATE_2		EQU	00011111b

;---------------------------------------------------------------------------
; Local Driver Flags
;---------------------------------------------------------------------------

KB_FLAGS_ERROR		EQU	10000000b
KB_FLAGS_RESEND		EQU	01000000b
KB_FLAGS_ACK		EQU	00100000b
KB_FLAGS_E0		EQU	00000001b
KB_FLAGS_E1		EQU	00000010b
KB_FLAGS_E1_B		EQU	00000011b

;---------------------------------------------------------------------------
; Local Driver Shift State
;---------------------------------------------------------------------------

KB_SHIFT_NONE		EQU	00000000b
KB_SHIFT_LEFT_SHIFT	EQU	00000001b
KB_SHIFT_RIGHT_SHIFT	EQU	00000010b
KB_SHIFT_SHIFT		EQU	00000011b
KB_SHIFT_LEFT_CTRL	EQU	00000100b
KB_SHIFT_RIGHT_CTRL	EQU	00001000b
KB_SHIFT_CTRL		EQU	00001100b
KB_SHIFT_LEFT_ALT	EQU	00010000b
KB_SHIFT_RIGHT_ALT	EQU	00100000b
KB_SHIFT_ALT		EQU	00110000b
KB_SHIFT_LEFT_WIN	EQU	01000000b
KB_SHIFT_RIGHT_WIN	EQU	10000000b
KB_SHIFT_WIN		EQU	11000000b

;---------------------------------------------------------------------------
; Local Driver State Keys
;---------------------------------------------------------------------------

KB_STATE_SCROLL		EQU	00000001b
KB_STATE_NUM		EQU	00000010b
KB_STATE_CAPS		EQU	00000100b
KB_STATE_INSERT		EQU	00001000b
KB_STATE_SCROLL_DOWN	EQU	00010000b
KB_STATE_NUM_DOWN	EQU	00100000b
KB_STATE_CAPS_DOWN	EQU	01000000b
KB_STATE_PAUSE		EQU	10000000b

;---------------------------------------------------------------------------
; IBM Virtual Keyboard Codes (INT16) & Extensions
;---------------------------------------------------------------------------

VK_ESC			EQU	011Bh
VK_BACKSPACE		EQU	0E08h
VK_TAB			EQU	0F09h
VK_ENTER		EQU	1C0Dh

VK_SHIFT_ESC		EQU	011Bh
VK_SHIFT_BACKSPACE	EQU	0E08h
VK_SHIFT_TAB		EQU	0F09h
VK_SHIFT_ENTER		EQU	1C0Dh

VK_CTRL_ESC		EQU	011Bh
VK_CTRL_BACKSPACE	EQU	0E08h
VK_CTRL_TAB		EQU	0F09h
VK_CTRL_ENTER		EQU	1C0Ah

VK_ALT_ESC		EQU	011Bh
VK_ALT_BACKSPACE	EQU	0E08h
VK_ALT_TAB		EQU	0F09h
VK_ALT_ENTER		EQU	1C0Dh

VK_0			EQU	0B30h
VK_1			EQU	0231h
VK_2			EQU	0332h
VK_3			EQU	0433h
VK_4			EQU	0534h
VK_5			EQU	0635h
VK_6			EQU	0736h
VK_7			EQU	0837h
VK_8			EQU	0938h
VK_9			EQU	0A39h

VK_SHIFT_0		EQU	0B00h + ")"
VK_SHIFT_1		EQU	0200h + "!"
VK_SHIFT_2		EQU	0300h + '"'
VK_SHIFT_3		EQU	0400h + ""
VK_SHIFT_4		EQU	0500h + "$"
VK_SHIFT_5		EQU	0600h + "%"
VK_SHIFT_6		EQU	0700h + "^"
VK_SHIFT_7		EQU	0800h + "&"
VK_SHIFT_8		EQU	0900h + "*"
VK_SHIFT_9		EQU	0A00h + "("

VK_CTRL_0		EQU	0B00h
VK_CTRL_1		EQU	0200h
VK_CTRL_2		EQU	0300h
VK_CTRL_3		EQU	0400h
VK_CTRL_4		EQU	0500h
VK_CTRL_5		EQU	0600h
VK_CTRL_6		EQU	0700h
VK_CTRL_7		EQU	0800h
VK_CTRL_8		EQU	0900h
VK_CTRL_9		EQU	0A00h

VK_ALT_0		EQU	8100h
VK_ALT_1		EQU	7800h
VK_ALT_2		EQU	7900h
VK_ALT_3		EQU	7A00h
VK_ALT_4		EQU	7B00h
VK_ALT_5		EQU	7C00h
VK_ALT_6		EQU	7D00h
VK_ALT_7		EQU	7E00h
VK_ALT_8		EQU	7F00h
VK_ALT_9		EQU	8000h
				
VK_A			EQU	1E00h + "a"
VK_B			EQU	3000h + "b"
VK_C			EQU	2D00h + "c"
VK_D			EQU	2000h + "d"
VK_E			EQU	1200h + "e"
VK_F			EQU	2100h + "f"
VK_G			EQU	2200h + "g"
VK_H			EQU	2300h + "h"
VK_I			EQU	1700h + "i"
VK_J			EQU	2400h + "j"
VK_K			EQU	2500h + "k"
VK_L			EQU	2600h + "l"
VK_M			EQU	3200h + "m"
VK_N			EQU	3100h + "n"
VK_O			EQU	1800h + "o"
VK_P			EQU	1900h + "p"
VK_Q			EQU	1000h + "q"
VK_R			EQU	1300h + "r"
VK_S			EQU	1F00h + "s"
VK_T			EQU	1400h + "t"
VK_U			EQU	1600h + "u"
VK_V			EQU	2F00h + "v"
VK_W			EQU	1100h + "w"
VK_X			EQU	2D00h + "x"
VK_Y			EQU	1500h + "y"
VK_Z			EQU	2C00h + "z"

VK_SHIFT_A		EQU	1E00h + "A"
VK_SHIFT_B		EQU	3000h + "B"
VK_SHIFT_C		EQU	2D00h + "C"
VK_SHIFT_D		EQU	2000h + "D"
VK_SHIFT_E		EQU	1200h + "E"
VK_SHIFT_F		EQU	2100h + "F"
VK_SHIFT_G		EQU	2200h + "G"
VK_SHIFT_H		EQU	2300h + "H"
VK_SHIFT_I		EQU	1700h + "I"
VK_SHIFT_J		EQU	2400h + "J"
VK_SHIFT_K		EQU	2500h + "K"
VK_SHIFT_L		EQU	2600h + "L"
VK_SHIFT_M		EQU	3200h + "M"
VK_SHIFT_N		EQU	3100h + "N"
VK_SHIFT_O		EQU	1800h + "O"
VK_SHIFT_P		EQU	1900h + "P"
VK_SHIFT_Q		EQU	1000h + "Q"
VK_SHIFT_R		EQU	1300h + "R"
VK_SHIFT_S		EQU	1F00h + "S"
VK_SHIFT_T		EQU	1400h + "T"
VK_SHIFT_U		EQU	1600h + "U"
VK_SHIFT_V		EQU	2F00h + "V"
VK_SHIFT_W		EQU	1100h + "W"
VK_SHIFT_X		EQU	2D00h + "X"
VK_SHIFT_Y		EQU	1500h + "Y"
VK_SHIFT_Z		EQU	2C00h + "Z"

VK_CTRL_A		EQU	1E01h
VK_CTRL_B		EQU	3002h
VK_CTRL_C		EQU	2D03h
VK_CTRL_D		EQU	2004h
VK_CTRL_E		EQU	1205h
VK_CTRL_F		EQU	2106h
VK_CTRL_G		EQU	2207h
VK_CTRL_H		EQU	2308h
VK_CTRL_I		EQU	1709h
VK_CTRL_J		EQU	240Ah
VK_CTRL_K		EQU	250Bh
VK_CTRL_L		EQU	260Ch
VK_CTRL_M		EQU	320Dh
VK_CTRL_N		EQU	310Eh
VK_CTRL_O		EQU	180Fh
VK_CTRL_P		EQU	1910h
VK_CTRL_Q		EQU	1011h
VK_CTRL_R		EQU	1312h
VK_CTRL_S		EQU	1F13h
VK_CTRL_T		EQU	1414h
VK_CTRL_U		EQU	1615h
VK_CTRL_V		EQU	2F16h
VK_CTRL_W		EQU	1117h
VK_CTRL_X		EQU	2D18h
VK_CTRL_Y		EQU	1519h
VK_CTRL_Z		EQU	151Ah

VK_ALT_A		EQU	1E00h
VK_ALT_B		EQU	3000h
VK_ALT_C		EQU	2D00h
VK_ALT_D		EQU	2000h
VK_ALT_E		EQU	1200h
VK_ALT_F		EQU	2100h
VK_ALT_G		EQU	2200h
VK_ALT_H		EQU	2300h
VK_ALT_I		EQU	1700h
VK_ALT_J		EQU	2400h
VK_ALT_K		EQU	2500h
VK_ALT_L		EQU	2600h
VK_ALT_M		EQU	3200h
VK_ALT_N		EQU	3100h
VK_ALT_O		EQU	1800h
VK_ALT_P		EQU	1900h
VK_ALT_Q		EQU	1000h
VK_ALT_R		EQU	1300h
VK_ALT_S		EQU	1F00h
VK_ALT_T		EQU	1400h
VK_ALT_U		EQU	1600h
VK_ALT_V		EQU	2F00h
VK_ALT_W		EQU	1100h
VK_ALT_X		EQU	2D00h
VK_ALT_Y		EQU	1500h
VK_ALT_Z		EQU	2C00h

VK_F1			EQU	3B00h
VK_F2			EQU	3C00h
VK_F3			EQU	3D00h
VK_F4			EQU	3E00h
VK_F5			EQU	3F00h
VK_F6			EQU	4000h
VK_F7			EQU	4100h
VK_F8			EQU	4200h
VK_F9			EQU	4300h
VK_F10			EQU	4400h
VK_F11			EQU	8500h
VK_F12			EQU	8600h

VK_SHIFT_F1		EQU	5400h
VK_SHIFT_F2		EQU	5500h
VK_SHIFT_F3		EQU	5600h
VK_SHIFT_F4		EQU	5700h
VK_SHIFT_F5		EQU	5800h
VK_SHIFT_F6		EQU	5900h
VK_SHIFT_F7		EQU	5A00h
VK_SHIFT_F8		EQU	5B00h
VK_SHIFT_F9		EQU	5C00h
VK_SHIFT_F10		EQU	5D00h
VK_SHIFT_F11		EQU	8700h
VK_SHIFT_F12		EQU	8800h

VK_CTRL_F1		EQU	5E00h
VK_CTRL_F2		EQU	5F00h
VK_CTRL_F3		EQU	6000h
VK_CTRL_F4		EQU	6100h
VK_CTRL_F5		EQU	6200h
VK_CTRL_F6		EQU	6300h
VK_CTRL_F7		EQU	6400h
VK_CTRL_F8		EQU	6500h
VK_CTRL_F9		EQU	6600h
VK_CTRL_F10		EQU	6700h
VK_CTRL_F11		EQU	8900h
VK_CTRL_F12		EQU	8A00h

VK_ALT_F1		EQU	6800h
VK_ALT_F2		EQU	6900h
VK_ALT_F3		EQU	6A00h
VK_ALT_F4		EQU	6B00h
VK_ALT_F5		EQU	6C00h
VK_ALT_F6		EQU	6D00h
VK_ALT_F7		EQU	6E00h
VK_ALT_F8		EQU	6F00h
VK_ALT_F9		EQU	7000h
VK_ALT_F10		EQU	7100h
VK_ALT_F11		EQU	8B00h
VK_ALT_F12		EQU	8C00h

