;---------------------------------------------------------------------------
;
;			PCI Architecture Definitions
;
;	   Copyright (c) 1999 by Thomas Kjoernes, all rights reserved.
;
;---------------------------------------------------------------------------

; PCI Function Address and Data Ports

PCI_CFG_ADDR			EQU	0CF8h
PCI_CFG_DATA			EQU	0CFCh

; Config Space Layout

PCI_REG_VENDOR_ID		EQU	00h
PCI_REG_DEVICE_ID		EQU	02h
PCI_REG_COMMAND			EQU	04h
PCI_REG_STATUS			EQU	06h
PCI_REG_REVISION_ID		EQU	08h
PCI_REG_PROG_INTERFACE		EQU	09h
PCI_REG_SUB_CLASS		EQU	0Ah
PCI_REG_CLASS_CODE		EQU	0Bh
PCI_REG_CACHE_LINE_SIZE		EQU	0Ch
PCI_REG_LATENCY			EQU	0Dh
PCI_REG_HEADER_TYPE		EQU	0Eh
PCI_REG_BIST			EQU	0Fh

PCI_REG_BAR0			EQU	10h
PCI_REG_BAR1			EQU	14h
PCI_REG_BAR2			EQU	18h
PCI_REG_BAR3			EQU	1Ch
PCI_REG_BAR4			EQU	20h
PCI_REG_BAR5			EQU	24h

PCI_REG_CARDBUS_CIS		EQU	28h

PCI_REG_SUBSYS_VENDOR_ID	EQU	2Ch
PCI_REG_SUBSYS_DEVICE_ID	EQU	2Eh

PCI_REG_ROM			EQU	30h
PCI_REG_CAP			EQU	34h

PCI_REG_RES_35			EQU	35h
PCI_REG_RES_36			EQU	36h
PCI_REG_RES_37			EQU	37h
PCI_REG_RES_38			EQU	38h
PCI_REG_RES_39			EQU	39h
PCI_REG_RES_3A			EQU	3Ah
PCI_REG_RES_3B			EQU	3Bh

PCI_REG_IRQ			EQU	3Ch
PCI_REG_INT_PIN			EQU	3Dh
PCI_REG_MIN_GRANT		EQU	3Eh
PCI_REG_MAX_LATENCY		EQU	3Fh

; Some Bit Definitions

PCI_MULTI_FUNCTION		EQU	10000000b

; PCI Classes

PCI_BASE_CLASS_STORAGE		EQU	01h
PCI_BASE_CLASS_NETWORK		EQU	02h
PCI_BASE_CLASS_DISPLAY		EQU	03h
PCI_BASE_CLASS_MULTIMEDIA	EQU	04h
PCI_BASE_CLASS_MEMORY		EQU	05h
PCI_BASE_CLASS_BRIDGE		EQU	06h
PCI_BASE_CLASS_COMMUNICATION	EQU	07h
PCI_BASE_CLASS_SYSTEM		EQU	08h
PCI_BASE_CLASS_INPUT		EQU	09h
PCI_BASE_CLASS_DOCKING		EQU	0Ah
PCI_BASE_CLASS_PROCESSOR	EQU	0Bh
PCI_BASE_CLASS_SERIAL		EQU	0ch

; PCI Sub-Classes

PCI_CLASS_NOT_DEFINED		EQU	0000h
PCI_CLASS_NOT_DEFINED_VGA	EQU	0001h

PCI_CLASS_STORAGE_SCSI		EQU	0100h
PCI_CLASS_STORAGE_IDE		EQU	0101h
PCI_CLASS_STORAGE_FLOPPY	EQU	0102h
PCI_CLASS_STORAGE_IPI		EQU	0103h
PCI_CLASS_STORAGE_RAID		EQU	0104h
PCI_CLASS_STORAGE_OTHER		EQU	0180h

PCI_CLASS_NETWORK_ETHERNET	EQU	0200h
PCI_CLASS_NETWORK_TOKEN_RING	EQU	0201h
PCI_CLASS_NETWORK_FDDI		EQU	0202h
PCI_CLASS_NETWORK_ATM		EQU	0203h
PCI_CLASS_NETWORK_OTHER		EQU	0280h

PCI_CLASS_DISPLAY_VGA		EQU	0300h
PCI_CLASS_DISPLAY_XGA		EQU	0301h
PCI_CLASS_DISPLAY_OTHER		EQU	0380h

PCI_CLASS_MULTIMEDIA_VIDEO	EQU	0400h
PCI_CLASS_MULTIMEDIA_AUDIO	EQU	0401h
PCI_CLASS_MULTIMEDIA_OTHER	EQU	0480h

PCI_CLASS_MEMORY_RAM		EQU	0500h
PCI_CLASS_MEMORY_FLASH		EQU	0501h
PCI_CLASS_MEMORY_OTHER		EQU	0580h

PCI_CLASS_BRIDGE_HOST		EQU	0600h
PCI_CLASS_BRIDGE_ISA		EQU	0601h
PCI_CLASS_BRIDGE_EISA		EQU	0602h
PCI_CLASS_BRIDGE_MC		EQU	0603h
PCI_CLASS_BRIDGE_PCI		EQU	0604h
PCI_CLASS_BRIDGE_PCMCIA		EQU	0605h
PCI_CLASS_BRIDGE_NUBUS		EQU	0606h
PCI_CLASS_BRIDGE_CARDBUS	EQU	0607h
PCI_CLASS_BRIDGE_OTHER		EQU	0680h

PCI_CLASS_COMM_SERIAL		EQU	0700h
PCI_CLASS_COMM_PARALLEL 	EQU	0701h
PCI_CLASS_COMM_OTHER		EQU	0780h

PCI_CLASS_SYSTEM_PIC		EQU	0800h
PCI_CLASS_SYSTEM_DMA		EQU	0801h
PCI_CLASS_SYSTEM_TIMER		EQU	0802h
PCI_CLASS_SYSTEM_RTC		EQU	0803h
PCI_CLASS_SYSTEM_OTHER		EQU	0880h

PCI_CLASS_INPUT_KEYBOARD	EQU	0900h
PCI_CLASS_INPUT_PEN		EQU	0901h
PCI_CLASS_INPUT_MOUSE		EQU	0902h
PCI_CLASS_INPUT_OTHER		EQU	0980h

PCI_CLASS_DOCKING_GENERIC	EQU	0A00h
PCI_CLASS_DOCKING_OTHER		EQU	0A01h

PCI_CLASS_PROCESSOR_386		EQU	0B00h
PCI_CLASS_PROCESSOR_486		EQU	0B01h
PCI_CLASS_PROCESSOR_PENTIUM	EQU	0B02h
PCI_CLASS_PROCESSOR_ALPHA	EQU	0B10h
PCI_CLASS_PROCESSOR_POWERPC	EQU	0B20h
PCI_CLASS_PROCESSOR_CO		EQU	0B40h

PCI_CLASS_SERIAL_FIREWIRE	EQU	0C00h
PCI_CLASS_SERIAL_ACCESS		EQU	0C01h
PCI_CLASS_SERIAL_SSA		EQU	0C02h
PCI_CLASS_SERIAL_USB		EQU	0C03h
PCI_CLASS_SERIAL_FIBER		EQU	0C04h
