;---------------------------------------------------------------------------
;
; 		  8254 Programmable Interval Timer Support
;
;     Copyright (c) 1999-2001 by Thomas Kjoernes, all rights reserved.
;
;
;	API Routines:
;
;	- ISA_PIT_ProgramChannel
;	
;---------------------------------------------------------------------------

	INCLUDE std.inc
	INCLUDE stdgroup.inc

	.386p

	PUBLIC	pitProgramChannel

codeSegment SEGMENT

;---------------------------------------------------------------------------
;	pitProgramChannel
;
;	Entry:
;	      	al = channel
;		ah = mode
;	       ecx = frequency	
;	Exit:
;		None
;
DefProc pitProgramChannel

	jecxz	pitProgramChannelFail

	cmp	al, 2
	ja	pitProgramChannelFail

	cmp	ah, 5
	ja	pitProgramChannelFail

	push	eax
	push	ecx
	push	edx

	mov	eax, 001234DDh	;
        xor     edx, edx        ; 1193181 / freq
	div	ecx		;

	xchg	eax, ecx	; ecx = divisor

	mov	dx, 0040h	;
	or	dl, al		;

	shl	al, 6		; place channel bits
	shl	ah, 1		; place mode bits
	or	al, ah		; set mode
	or	al, 00110000b	; set LSB/MSB

	mov	al, cl		; send counter LSB
	out	dx, al		;

	mov	al, ch		; send counter MSB
	out	dx, al		;

	pop	edx
	pop	ecx
	pop	eax

	clc
	ret

pitProgramChannelFail:
	stc
	ret

EndProc pitProgramChannel

codeSegment ENDS

;---------------------------------------------------------------------------
; Data
;---------------------------------------------------------------------------

dataSegment SEGMENT

dataSegment ENDS

;---------------------------------------------------------------------------
; BSS Data
;---------------------------------------------------------------------------

bssSegment SEGMENT

bssSegment ENDS

	END

