;---------------------------------------------------------------------------
;
; 		      PC Speaker Sound Support Routines
;
;     Copyright (c) 1999-2001 by Thomas Kjoernes, all rights reserved.
;
;
;	API Routines:
;
;	- ISA_SpeakerOn
;	- ISA_SpeakerOff
;
;---------------------------------------------------------------------------

	INCLUDE std.inc
	INCLUDE stdgroup.inc
	INCLUDE	isa.api

	.386p

	PUBLIC	speakerOn
	PUBLIC	speakerOff

codeSegment SEGMENT

;---------------------------------------------------------------------------
;	speakerOn - 
;
;	Entry:
;		eax = Frequency (Hz)
;	Exit:
;		None
;
DefProc speakerOn

	push	eax
	push	ecx
	push	edx

	; mode=3 (Square Wave), channel=2

	mov	ecx, eax
	mov	eax, 0302h
	APIcall	ISA_PIT_ProgramChannel

	; Speaker ON, Enable PIT Channel 2 Gate to Speaker

	in	al, 61h
	or	al, 00000011b
	out	61h, al

	pop	edx
	pop	ecx
	pop	eax
	ret

EndProc speakerOn

;---------------------------------------------------------------------------
;	speakerOff - 
;
;	Entry:
;		None
;	Exit:
;		None
;
DefProc speakerOff

	push	eax

	in	al, 61h
	and	al, 11111100b
	out	61h, al

	pop	eax
	ret

EndProc speakerOff

codeSegment ENDS

;---------------------------------------------------------------------------
; Data
;---------------------------------------------------------------------------

dataSegment SEGMENT

dataSegment ENDS

;---------------------------------------------------------------------------
; BSS Data
;---------------------------------------------------------------------------

bssSegment SEGMENT

bssSegment ENDS

	END

