;---------------------------------------------------------------------------
;
; 		     32-bit PM IDT and Interface Routines
;
;     Copyright (c) 1999-2001 by Thomas Kjoernes, all rights reserved.
;
;
;	API Routines:
;
;	- KERNEL_IdtGetEntry
;	- KERNEL_IdtSetEntry
;
;---------------------------------------------------------------------------

	INCLUDE	std.inc
	INCLUDE	stdgroup.inc

	.386p

	; Exports

	PUBLIC	idtGetEntry
	PUBLIC	idtSetEntry

codeSegment SEGMENT

;---------------------------------------------------------------------------
;	idtGetEntry
;
;	Entry:
;		 al = interrupt #
;	Exit:
;		ebx = handler offset
;		ecx = selector
;		edx = type
;
DefProc idtGetEntry

	pushfd
	push	eax

	cli

	movzx	eax, al
	lea	eax, kernelIDTDef[eax*8]

	push	[eax].idtOfsHigh
	push	[eax].idtOfsLow
	pop	ebx

	movzx	ecx, [eax].idtSelector
	movzx	edx, [eax].idtType

	pop	eax
	popfd
	ret

EndProc idtGetEntry

;---------------------------------------------------------------------------
;	idtSetEntry
;
;	Entry:
;		 al = interrupt #
;		ebx = handler offset
;		ecx = selector
;		edx = type
;	Exit:
;		None
;
DefProc idtSetEntry

	pushfd
	push	eax

	cli

	movzx	eax, al
	lea	eax, kernelIDTDef[eax*8]

	push	ebx
	pop	[eax].idtOfsLow
	pop	[eax].idtOfsHigh

	mov	[eax].idtSelector, cx
	mov	[eax].idtType, dl

	pop	eax
	popfd
	ret

EndProc idtSetEntry

codeSegment ENDS

;---------------------------------------------------------------------------
; Data
;---------------------------------------------------------------------------

	PUBLIC	kernelIDTPtr
	PUBLIC	kernelIDTDef
	PUBLIC	kernelIDTEnd

dataSegment SEGMENT

;---------------------------------------------------------------------------
; IDT register
;---------------------------------------------------------------------------

kernelIDTPtr	LABEL	FWORD
	DW	kernelIDTEnd-kernelIDTDef-1
	DD	kernelIDTDef
	DW	NULL

dataSegment ENDS

;---------------------------------------------------------------------------
; BSS Data
;---------------------------------------------------------------------------

bssSegment SEGMENT

;---------------------------------------------------------------------------
; IDT -- Interrupt Descriptor Table
;---------------------------------------------------------------------------

kernelIDTDef	LABEL	DWORD
	IDT	256 DUP (<>)
kernelIDTEnd	LABEL	DWORD

bssSegment ENDS

	END
