;---------------------------------------------------------------------------
;
; 			32-bit Task State Segment Handling
;
;     Copyright (c) 1999-2001 by Thomas Kjoernes, all rights reserved.
;
;
;	API Routines:
;
;	- KERNEL_TssGetRing0ESP
;	- KERNEL_TssSetRing0ESP
;
;---------------------------------------------------------------------------

	INCLUDE	std.inc
	INCLUDE	stdgroup.inc
	INCLUDE	kernel.api

	.386p

	; Exports

	PUBLIC	tssGetRing0ESP
	PUBLIC	tssSetRing0ESP

	PUBLIC	tssInit
	PUBLIC	tssDone

codeSegment SEGMENT

;---------------------------------------------------------------------------
;	tssGetRing0ESP
;
;	Entry:
;		None
;	Exit:
;		eax = Current Ring0 ESP
;
DefProc tssGetRing0ESP

	mov	eax, kernelTSS.tssESP0
	ret

EndProc tssGetRing0ESP

;---------------------------------------------------------------------------
;	tssSetRing0ESP
;
;	Entry:
;		eax = New Ring0 ESP
;	Exit:
;		eax = Old Ring0 ESP
;
DefProc tssSetRing0ESP

	xchg	eax, kernelTSS.tssESP0
	ret

EndProc tssSetRing0ESP

;---------------------------------------------------------------------------
;	tssInit
;
;	Entry:
;		None
;	Exit:
;		None
;
DefProc tssInit

	push	eax
	push	ebx
	push	ecx

	mov	eax, KERNEL_TSS
	mov	ebx, OFFSET kernelTSS
	mov	ecx, (kernelIOHnd-kernelTSS-1)
	mov	edx, DESC_TSS
	APIcall	KERNEL_GdtSetEntry

	ltr	ax

	mov	[ebx].tssSS0, ss
	mov	[ebx].tssTrap, 1
	mov	[ebx].tssIOPB, (kernelIOMap-kernelTSS)

	pop	ecx
	pop	ebx
	pop	eax
	ret

EndProc tssInit

;---------------------------------------------------------------------------
;	tssDone
;
;	Entry:
;		None
;	Exit:
;		None
;
DefProc tssDone
	ret
EndProc tssDone

codeSegment ENDS

;---------------------------------------------------------------------------
; Data
;---------------------------------------------------------------------------

dataSegment SEGMENT

dataSegment ENDS

;---------------------------------------------------------------------------
; BSS Data
;---------------------------------------------------------------------------

bssSegment SEGMENT

; Kernel TSS, I/O Bitmap and Top-level I/O Handler Table

kernelTSS	DB	SIZE TSS DUP (?)
kernelIRMap	DB	  32 DUP (?)
kernelIOMap	DB	8192 DUP (?)
kernelIOHnd	DD	  64 DUP (?)

bssSegment ENDS

	END

