;---------------------------------------------------------------------------
;
;				  Test Module
;
;     Copyright (c) 1999-2000 by Thomas Kjoernes, all rights reserved.
;
;---------------------------------------------------------------------------

	INCLUDE std.inc
	INCLUDE stdgroup.inc
	INCLUDE kernel.api

	.386p

	; Publics

codeSegment SEGMENT

	; Externs


; PCB -- Process Control Block

PCB		STRUC
pcbLink		DD	?
pcbID		DD	?
pcbFlags	DD	?
pcbRes0C	DD	?
pcbThreadList	DD	?
pcbResourceList	DD	?
pcbAddressSpace	DD	?
pcbMessageQueue	DD	?
PCB		ENDS

; TCB -- Thread Control Block

TCB		STRUC
tcbLink		DD	?
tcbID		DD	?
tcbProcess	DD	?
tcbFlags	DD	?
tcbPriority	DB	?
tcbRes11	DB	?
tcbRes12	DB	?
tcbRes13	DB	?
tcbCPUState	DD	?
tcbFPUState	DD	?
tcbRes1C	DD	?
TCB		ENDS

; CPU_STATE - x86 CPU State Structure

CPU_STATE	STRUC
cpuEFLAGS	DD	?
cpuESP0		DD	?
cpuESP		DD	?
cpuSS		DD	?
cpuEIP		DD	?
cpuCS		DD	?
cpuEAX		DD	?
cpuEBX		DD	?
cpuECX		DD	?
cpuEDX		DD	?
cpuESI		DD	?
cpuEDI		DD	?
cpuEBP		DD	?
cpuDS		DD	?
cpuES		DD	?
cpuFS		DD	?
cpuGS		DD	?
CPU_STATE	ENDS

; FPU_STATE - x86 FPU State Structure, FSAVE/FRSTOR, FXSAVE/FXRSTOR

FPU_STATE	STRUC
		DB	512 DUP (?)
FPU_STATE	ENDS


;---------------------------------------------------------------------------
;	psGetCPUState
;
;	Entry:
;		None
;	Exit:
;		None
;
psGetCPUState PROC NEAR

	push	ebx
	push	esi
	push	ds

	push	ss
	pop	ds

	mov	ebx, psCurrentThread

	mov	esi, [ebx].tcbCPUState

	mov	[esi].cpuEAX. eax
	mov	[esi].cpuECX, ecx
	mov	[esi].cpuEDX, edx
	mov	[esi].cpuEDI, edi
	mov	[esi].cpuEBP, ebp

	mov	[esi].cpuES, es
	mov	[esi].cpuFS, fs
	mov	[esi].cpuGS, gs

	mov	edi, psCurrentProcess

	pop	[esi].cpuDS
	pop	[esi].cpuESI
	pop	[esi].cpuEBX

	pop	ebp		; RET address

	pop	edx		; pop EIP
	pop	ecx		; pop CS
	pop	eax		; pop EFLAGS

	mov	[esi].cpuEFLAGS, eax
	mov	[esi].cpuEIP, edx
	mov	[esi].cpuCS, ecx

	; Kernel Thread?

;	test	[ebx].tcpFlags, TCB_FLAGS_RING0
;	jnz	psGetCPUStateNoCR3

	; Process Switch?

	cmp	edi, [ebx].tcbProcess
	je	psGetCPUStateNoCR3

	mov	edi, [ebx].tcbProcess
	mov	psCurrentProcess, edi

	; Switch Address Spaces (CR3)

	mov	edx, [edi].pcbAddressSpace
	mov	cr3, edx

psGetCPUStateNoCR3:

	test	eax, EFLAGS_VM
	jnz	psGetCPUStateV86

	test	ecx, RPL3
	jnz	psGetCPUStateRing3

	jmp	ebp

psGetCPUStateRing3:
	pop	[esi].cpuESP
	pop	[esi].cpuSS
	jmp	ebp

psGetCPUStateV86:
	pop	[esi].cpuESP
	pop	[esi].cpuSS
	pop	[esi].cpuDS
	pop	[esi].cpuES
	pop	[esi].cpuFS
	pop	[esi].cpuGS
	jmp	ebp

psGetCPUState ENDP


;---------------------------------------------------------------------------
;	mainEntryPoint - TEST.SYS entry point
;
;	Entry (Stack):
;
;		DWORD = return address
;
;	Entry (Registers):
;
;		ebx = our memory block base -- "module handle"
;		ecx = our memory block size
;
mainEntryPoint PROC NEAR

	mov	ecx, SIZE CPU_STATE
	mov	ecx, SIZE FPU_STATE


	ret

mainEntryPoint ENDP

codeSegment ENDS

;---------------------------------------------------------------------------
; Data
;---------------------------------------------------------------------------

dataSegment SEGMENT

dataSegment ENDS

;---------------------------------------------------------------------------
; BSS Data
;---------------------------------------------------------------------------

bssSegment SEGMENT

bssSegment ENDS

	END	mainEntryPoint
